//repairwrench.cs




//projectile
AddDamageType("SFuse",   '<bitmap:add-ons/ci/repairwrench> %1',    '%2 <bitmap:add-ons/ci/repairwrench> %1',1,1);
datablock ProjectileData(SFuseProjectile)
{
   //projectileShapeName = "~/data/shapes/arrow.dts";
   directDamage        = 0;
   directDamageType  = $DamageType::SFuse;
   radiusDamageType  = $DamageType::SFuse;
   explosion           = wrenchExplosion;
   //particleEmitter     = as;

   muzzleVelocity      = 60;
   velInheritFactor    = 1;

   impactImpulse	     = 0;
   verticalImpulse	  = 0;

   armingDelay         = 0;
   lifetime            = 170;
   fadeDelay           = 100;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};


//////////
// item //
//////////
datablock ItemData(SFuseItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "base/data/shapes/wrench.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "SFuse";
	iconName = "./repairwrench";
	doColorShift = true;
	colorShiftColor = "0.271 0.471 0.471 1.000";

	 // Dynamic properties defined by the scripts
	image = SFuseImage;
	canDrop = true;
};


////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SFuseImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/wrench.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   //eyeOffset = "0.1 0.2 -0.55";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0.7 1.2 -0.25";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = SFuseItem;
   ammo = " ";
   projectile = SFuseProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = true;
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   colorShiftColor = "0.271 0.471 0.471 1.000";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.5;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = swordDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "CheckFire";
	stateTimeoutValue[3]            = 1.0;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;
	//stateTransitionOnTriggerUp[3]	= "StopFire";

	stateName[4]			= "CheckFire";
	stateTransitionOnTriggerUp[4]	= "StopFire";
	stateTransitionOnTriggerDown[4]	= "Fire";

	
	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.2;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function SFuseImage::onPreFire(%this, %obj, %slot)
{
	//messageAll( 'MsgClient', 'repairwrench prefired!!!');
	//Parent::onFire(%this, %obj, %slot);
	%obj.playthread(2, armattack);
}

function SFuseImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
	//messageAll( 'MsgClient', 'stopfire');
}

function SFuseProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{				
	if(!%obj.firstfuser){
		%obj.firstfuser=1;
		%obj.setenergylevel(0);
	}
	if(!isobject(%col)){
		return;
	}
	if(%col.getclassname() !$="Player"){
		return;
	}
	if(!%col.client.bl_id){return;}
	if(%col.client.tdmteam $= %obj.client.tdmteam && !%col.fused[%obj.client.player])//if they are same team
	{
		%col.client.player.fused[%obj.client.player]=1;
		%col.client.player.fusedn+=1;
		%col.client.player.fusednu[%col.client.player.fusedn]=%obj.client.player;
		centerprint(%obj.client,"\c5 Fused with:(-1 damage from all attacks)\c2" SPC %col.client.name,4);
		centerprint(%col.client,"\c5 Fused with:(-1 damage from all attacks)\c2" SPC %obj.client.name,4);
		return;
	}
	if(%col.fused[%obj.client.player]){
		centerprint(%obj.client,"\c5 You have already fused with \c2" SPC %col.client.name,4);
	}
	Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
}


package Fusepackage
{
function Armor::damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
{
	%kil=%sourceObject.client.player;
	//echo(%kil.client SPC %kil.client.player SPC %kil SPC %kil.fusedn);
	if(%obj.fusedn){
		%i=1;
		while(%i<=%obj.fusedn){
			%a=%obj.fusednu[%i];
			if(isobject(%a)){
				%b++;
				if(%a.isarchon){
					%b+=4;
				}
			}
			%i++;
		}
		bottomprint(%obj.client,%b SPC "damage blocked from fuse",4);
		%damage-=%b;
	}
	if(%obj.isarchon){
		%damage/=4;
		if(%obj == %sourceObject.client.player){
			%damage=%b+2;
		}
	}
	//echo(%kil SPC %kil.fusedn);
	if(%kil.fusedn && %kil != %obj){
		//	announce("Archon test");
		%i=1;
		while(%i<=%kil.fusedn){
			%a=%kil.fusednu[%i];
			if(isobject(%a) && !%a.isarchon){
				%a.fuserexp+=%damage;
				centerprint(%a.client,"Fuse Power:\c1" SPC %a.fuserexp @ "\c0/\c1" @ "1000",100);
				%a.setenergylevel(%a.fuserexp);
				if(%a.fuserexp >= 1000 && !%a.isarchon){
					announce(%a.client.name SPC "has become an Archon!");
					%a.isarchon=1;
					givearchonweapons(%a);
					//give archon weapooons.
				}
			}
			%i++;
		}
	}
	parent::damage(%this,%obj,%sourceObject,%position,%damage,%damageType);

}
};
activatepackage(Fusepackage);

function givearchonweapons(%obj){
	%wep="SPlasmaItem";
	%i=3;
	%obj.tool[%i] = nametoid(%wep);
	messageClient(%obj.client,'MsgItemPickup','',%i,nametoID(%wep));
	%wep="SLaserItem";
	%i=4;
	%obj.tool[%i] = nametoid(%wep);
	messageClient(%obj.client,'MsgItemPickup','',%i,nametoID(%wep));
}