//Sshotgun.cs
//exec("add-ons/blockrace/weapon_rpistol.cs");

//shell
datablock DebrisData(SshotgunShellDebris)
{
	shapeFile = "Add-ons/Weapon_Gun/gunShell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};


//muzzle flash effects
datablock ParticleData(SshotgunFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SshotgunFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SshotgunFlashParticle";
};

datablock ParticleData(SshotgunSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 325;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SshotgunSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SshotgunSmokeParticle";
};


datablock ParticleData(SshotgunExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.1;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "./exp1spark";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.6 0.2 0.9";
	colors[1]     = "0.9 0.4 0.2 0.0";
	sizes[0]      = 0.45;
	sizes[1]      = 0.55;

	useInvAlpha = true;
};
datablock ParticleEmitterData(SshotgunExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SshotgunExplosionParticle";
};


datablock ParticleData(SshotgunExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 100;
	textureName          = "./exp1spark";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1 1 0.0 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.20;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SshotgunExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SshotgunExplosionRingParticle";
};

datablock ExplosionData(SshotgunExplosion)
{
   //explosionShape = "";
	soundProfile = bulletHitSound;

   lifeTimeMS = 70;

   particleEmitter = SshotgunExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = SshotgunExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
   damageRadius = 1.0;
   radiusDamage = 5;

   impulseRadius = 1.0;
   impulseForce = 100;
};


AddDamageType("Sshotgun",   '%1\c1 died of explosive shotgun rounds.',    '%2 \c1filled\c0 %1 \c1with shotgun bullets.',0.5,1);
datablock ProjectileData(SshotgunProjectile)
{
   projectileShapeName = "Add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 3;
   directDamageType    = $DamageType::Sshotgun;
   radiusDamageType    = $DamageType::Sshotgun;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 000;
   explosion           = SshotgunExplosion;
   particleEmitter     = RbulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 1;

   armingDelay         = 00;
   lifetime            = 2000;
   fadeDelay           = 1500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};


//////////
// item //
//////////
datablock ItemData(SshotgunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shotgun1.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Sshotgun";
	iconName = "Add-ons/Weapon_Gun/gun";
	doColorShift = true;
	colorShiftColor = "0.90 0.95 0.95 1.000";

	 // Dynamic properties defined by the scripts
	image = SshotgunImage;
	canDrop = true;
};


////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SshotgunImage)
{
   // Basic Item properties
   shapeFile = "./shotgun1.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = SshotgunProjectile;
   projectileType = Projectile;

	casing = SshotgunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = SshotgunItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.02;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= SshotgunFlashEmitter;
	stateEmitterTime[2]				= 0.08;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= gunShot1Sound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= SshotgunSmokeEmitter;
	stateEmitterTime[3]				= 0.01;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.47;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";

};

function SshotgunImage::onFire(%this,%obj,%slot)
{
	%reloadtime="2500";
	if(!%obj.bulletloaded["shotgun"]){%obj.bulletloaded["shotgun"]=7;}
	if(!%obj.shotguncritchance){%obj.shotguncritchance=4;}
	if(%obj.shotgunreloading){
		if(1 > %obj.bulletloaded["shotgun"]-1){// || 2 > %obj.bulletloaded["shotgun"]-1 && %obj.client.curclass$="fuser"
			return;
		}
		if(1 > %obj.bulletloaded["shotgun"]-1){// || 2 > %obj.bulletloaded["shotgun"]-1 && %obj.client.curclass$="harvester"
			return;
		}
		%obj.cancelshotgunreloading=1;
		%obj.shotgunreloading=0;
		cancel($shotgunreload[%obj]);
		$shotgunreload[%obj]=0;
	}
	if(1 > %obj.bulletloaded["shotgun"]-1){// || 2 > %obj.bulletloaded["shotgun"]-1 && %obj.client.curclass$="fuser" || 2 > %obj.bulletloaded["shotgun"]-1 && %obj.client.curclass$="harvester"
		%obj.playThread(2, shiftdown);
		//centerprint(%obj.client,"Reloading...\c1" SPC %obj.bulletloaded["shotgun"]-1 @ "\c0/\c1" @ 18 - %obj.bulletexpended["shotgun"],200);
		%obj.shotgunreloading=1;
		$shotgunreload[%obj]=schedule(%reloadtime,0,"Sshotgunreload",%obj);
		return;
	}
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftAway);

	%projectile = %this.projectile;
	%typer="SshotgunProjectile";
	%a=getrandom(1,%obj.shotguncritchance+2);
	///if(%a==1 && $classon){
	//	%typer="SshotgunCritProjectile";
	//	%obj.shotguncritchance+=6;
	//}
	%spread = 0.0028;
	%pvec = %obj.client.player.getvelocity();
	if(getword(%pvec,0) + getword(%pvec,1) + getword(%pvec,2) > 1 || getword(%pvec,0) + getword(%pvec,1) + getword(%pvec,2) < -1){
		%spread += 0.0008;
	}else{
		%spread -= 0.0008;
	}
	%shellcount=6;
	%scale="1 1 1";
	if(2 > %obj.bulletloaded["shotgun"]-1 && %obj.client.curclass$="fuser" || 2 > %obj.bulletloaded["shotgun"]-1 && %obj.client.curclass$="harvester"){
		%pullone=1;
	}
	if(%obj.client.curclass$="fuser" || %obj.client.curclass$="harvester"){
		%scale="0.6 0.6 0.6";
		%shellcount=6;
		%spread-=0.0008;
		if(%pullone){
			%shellcount=3;
		}
	}
	%obj.bulletloaded["shotgun"]-=1;
	if(%obj.client.curclass$="fuser" || %obj.client.curclass$="harvester"){
		if(!%pullone){
			%obj.bulletloaded["shotgun"]-=1;
		}
	}
	centerprint(%obj.client,"\c0Shots left:\c1" SPC %obj.bulletloaded["shotgun"]-1 @ "\c0/\c1" @ 18 - %obj.bulletexpended["shotgun"],400);

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity+%bonus);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		

		%p = new (%this.projectileType)()
		{
			dataBlock = %typer;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		%p.setscale(%scale);
		MissionCleanup.add(%p);
	}

	if(1 > %obj.bulletloaded["shotgun"]-1 || %obj.bulletloaded["shotgun"] < 7){
		if(!%obj.shotgunreloading&&$shotgunreload[%obj]==0){
			%obj.playThread(2, shiftdown);
			centerprint(%obj.client,"Reloading...\c1" SPC %obj.bulletloaded["shotgun"]-1 @ "\c0/\c1" @ 18 - %obj.bulletexpended["shotgun"],200);
			%obj.shotgunreloading=1;
			$shotgunreload[%obj]=schedule(%reloadtime,0,"Sshotgunreload",%obj);
		}
	}
	return %p;
	

}

function Sshotgunreload(%obj){
	if(!isobject(%obj)||%obj.getdamagelevel() >= %obj.getdatablock().maxdamage){
		return;
	}
	if(%obj.cancelshotgunreloading){
		%obj.cancelshotgunreloading=0;
	}
	if(%obj.getmountedimage(0)!$=nametoid("Sshotgunimage")){
		%obj.cancelshotgunreloading=1;
		%obj.shotguncritchance-=2;
		if(%obj.shotguncritchance<4){
			%obj.shotguncritchance=4;
		}
		%obj.shotgunreloading=0;
		cancel($shotgunreload[%obj]);
		$shotgunreload[%obj]=0;
		return;
	}
	if(%obj.bulletexpended["shotgun"] >= 18){
		%obj.cancelshotgunreloading=1;
		%obj.shotguncritchance-=2;
		if(%obj.shotguncritchance<4){
			%obj.shotguncritchance=4;
		}
		%obj.shotgunreloading=0;
		cancel($shotgunreload[%obj]);
		$shotgunreload[%obj]=0;
		centerprint(%obj.client,"No ammo...\c1" SPC %obj.bulletloaded["shotgun"]-1 @ "\c0/\c1" @ 18 - %obj.bulletexpended["shotgun"],200);
		return;
	}
	%obj.playThread(2, shiftright);
	%reloadtime="1200";
	%obj.bulletloaded["shotgun"]+=1;
	%obj.bulletexpended["shotgun"]++;
	%obj.shotgunshellsfired--;
	if(%obj.shotgunshellsfired<0){
		%obj.shotgunshellsfired=0;	
	}
	centerprint(%obj.client,"Reloading...\c1" SPC %obj.bulletloaded["shotgun"]-1 @ "\c0/\c1" @ 18 - %obj.bulletexpended["shotgun"],200);
	if(%obj.bulletloaded["shotgun"] < 7){
		$shotgunreload[%obj]=schedule(%reloadtime,0,"Sshotgunreload",%obj);
	}else{
		%obj.shotguncritchance-=6;
		if(%obj.shotguncritchance<4){
			%obj.shotguncritchance=4;
		}
		%obj.shotgunreloading=0;
		$shotgunreload[%obj]=0;
	}
}


package shotgunmountreload
{
function SshotgunImage::onMount(%this,%obj,%slot)
{
	if(!%obj.client.player.bulletloaded["shotgun"]){%obj.client.player.bulletloaded["shotgun"]=7;}
	centerprint(%obj.client,"Ammo...\c1" SPC %obj.client.player.bulletloaded["shotgun"]-1 @ "\c0/\c1" @ 18 - %obj.client.player.bulletexpended["shotgun"],200);
	if(1 > %obj.client.player.bulletloaded["shotgun"]-1 || %obj.client.player.bulletloaded["shotgun"] < 7){
		if(!%obj.client.player.shotgunreloading&&$shotgunreload[%obj.client.player]==0){
			%obj.client.player.playThread(2, shiftdown);
			centerprint(%obj.client,"Reloading...\c1" SPC %obj.client.player.bulletloaded["shotgun"]-1 @ "\c0/\c1" @ 18 - %obj.client.player.bulletexpended["shotgun"],200);
			%obj.client.player.shotgunreloading=1;
			$shotgunreload[%obj.client.player]=schedule(2500,0,"Sshotgunreload",%obj.client.player);
		}
	}
	parent::onMount(%this,%obj,%slot);
}


};
activatepackage(shotgunmountreload);


$bulletloadedmax["shotgun"]=18;

registerOutputEvent("Player", "Scav_add_ammo", "string 32 100" TAB "int 1 2000 1", 0);

function Player::Scav_add_ammo(%player,%type,%amount){
	if(firstword(%type) $= "hp"){//i.e hp fallen
		if(getword(%type,1) $= %player.client.curclass){
			%player.addhealth(%amount);
		}
		return;
	}
	%oldamount=%player.bulletexpended[%type];
	%player.bulletexpended[%type] -= %amount;
	if(%player.bulletexpended[%type] < 0){
		%player.bulletexpended[%type]=0;
	}
	if(%player.bulletexpended[%type] > $bulletloadedmax[%type]){
		%player.bulletexpended[%type]=$bulletloadedmax[%type];
	}
	%obj=%player;
	if(%obj.bulletloaded[%type]-1 >= 0 && %player.bulletexpended[%type] != %oldamount){ 
		centerprint(%obj.client,"Ammo recieved...\c1" SPC %obj.bulletloaded[%type]-1 @ "\c0/\c1" @ $bulletloadedmax[%type] - %obj.bulletexpended[%type],200);
	}
}


function SshotgunProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{			
	if(!isobject(%col)){
		Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		return;
	}
	if(%col.getclassname() $= "Player" || %col.getclassname() $= "AIPlayer"){
		if(%obj.client.curclass $= "harvester"){
			//Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
			%obj.client.player.drainedenergy+=1;
			%obj.client.player.setdamagelevel(%obj.client.player.getdamagelevel() - 1);
		}
		%colds=vectordist(%obj.client.player.gettransform(),%col.gettransform());
		//announce(%colds);
		if(%colds<24){
			if(%colds<6 && %obj.client.curclass!$="fuser" && %obj.client.curclass!$="harvester"){
				Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
			}
			Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
			if(%colds > 12 && %obj.client.curclass$="fuser"){
				Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
			}
		}else{
			bottomprint(%obj.client,"Tip: Shotgun does less damage at a distance",3);
		}
		//bottomprint(%client,"Tip: Shotgun does less damage at a distance",3);
		Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
		return;
	}
	
	//Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
}

