//SRifle.cs



//shell
datablock DebrisData(SRifleShellDebris)
{
	shapeFile = "Add-ons/Weapon_Gun/gunShell.dts";
	lifetime = 4.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};


//muzzle flash effects
datablock ParticleData(SRifleFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.9 0.0 0.9";
	colors[1]     = "0.9 0.5 0.0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 1.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SRifleFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SRifleFlashParticle";
};

datablock ParticleData(SRifleSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 325;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.5 0.5 0.9";
	colors[1]     = "0.5 0.5 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SRifleSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SRifleSmokeParticle";
};


//bullet trail effects
//datablock ParticleData(RbulletTrailParticle)
//{
//	dragCoefficient      = 3;
//	gravityCoefficient   = -0.0;
//	inheritedVelFactor   = 1.0;
//	constantAcceleration = 0.0;
//	lifetimeMS           = 1025;
//	lifetimeVarianceMS   = 55;
//	textureName          = "base/data/particles/dot";
//	spinSpeed		= 10.0;
//	spinRandomMin		= -500.0;
//	spinRandomMax		= 500.0;
//	colors[0]     = "0.7 0.3 0.3 0.07";
//	colors[1]     = "0.7 0.3 0.3 0.07";
//	sizes[0]      = 0.07;
//	sizes[1]      = 0.07;
//
//	useInvAlpha = false;
//};
//datablock ParticleEmitterData(RbulletTrailEmitter)
//{
//   ejectionPeriodMS = 1;
//   periodVarianceMS = 0;
//   ejectionVelocity = 0.0;
//   velocityVariance = 0.0;
//   ejectionOffset   = 0.0;
//   thetaMin         = 0;
//   thetaMax         = 90;
//   phiReferenceVel  = 0;
//   phiVariance      = 360;
//   overrideAdvance = false;
//   particles = "RbulletTrailParticle";
//};
datablock ParticleData(RbulletTrailParticle)
{
	dragCoefficient      = 99;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1525;
	lifetimeVarianceMS   = 1;
	textureName          = "base/data/particles/dot";
	spinSpeed		= 0.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.7 0.7 0.7 0.3";
	colors[1]     = "0.7 0.4 0.1 0.0";
	sizes[0]      = 0.05;
	sizes[1]      = 0.04;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RbulletTrailEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RbulletTrailParticle";
};

//bullet trail effects
datablock ParticleData(RbulletCritTrailParticle)
{
	dragCoefficient      = 2;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 1.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1025;
	lifetimeVarianceMS   = 105;
	textureName          = "base/data/particles/bubble";
	spinSpeed		= 50.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.9 0.5 0.2 0.19";
	colors[1]     = "0.9 0.5 0.2 0.19";
	sizes[0]      = 0.1;
	sizes[1]      = 0.1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(RbulletCritTrailEmitter)
{
   ejectionPeriodMS = 2;
   periodVarianceMS = 2;
   ejectionVelocity = 0.4;
   velocityVariance = 0.1;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 360;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "RbulletCritTrailParticle";
};

datablock ParticleData(SRifleExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.9 0.9 0.4 0.9";
	colors[1]     = "0.9 0.5 0.4 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.25;

	useInvAlpha = true;
};
datablock ParticleEmitterData(SRifleExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SRifleExplosionParticle";
};


datablock ParticleData(SRifleExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "1 1 0.0 0.9";
	colors[1]     = "0.9 0.0 0.0 0.0";
	sizes[0]      = 0.1;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SRifleExplosionRingEmitter)
{
	lifeTimeMS = 50;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SRifleExplosionRingParticle";
};

datablock ExplosionData(SRifleExplosion)
{
   //explosionShape = "";
	soundProfile = bulletHitSound;

   lifeTimeMS = 150;

   particleEmitter = SRifleExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = SRifleExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";
};


AddDamageType("SRifle",   '%1 \c1 took a rifle shot.',    '%2 \c1shot\c0 %1\c1 with a rifle.',0.5,1);
datablock ProjectileData(SRifleProjectile)
{
   projectileShapeName = "Add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 15;
   directDamageType    = $DamageType::SRifle;
   radiusDamageType    = $DamageType::SRifle;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 000;
   verticalImpulse	  = 000;
   explosion           = SRifleExplosion;
   particleEmitter     = RbulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 2000;
   fadeDelay           = 1500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};


//////////
// item //
//////////
datablock ItemData(SRifleItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "add-ons/script_blockrace/pioneerhg.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "SRifle";
	iconName = "add-ons/script_blockrace/pioneerhg";
	doColorShift = true;
	colorShiftColor = "0.45 0.45 0.45 1.000";

	 // Dynamic properties defined by the scripts
	image = SRifleImage;
	canDrop = true;
};


////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SRifleImage)
{
   // Basic Item properties
   shapeFile = "add-ons/script_blockrace/pioneerhg.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = SRifleProjectile;
   projectileType = Projectile;

	casing = SRifleShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = SRifleItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.09;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= SRifleFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= gunShot1Sound;
	stateEjectShell[2]       = true;

	stateName[3] = "Smoke";
	stateEmitter[3]					= SRifleSmokeEmitter;
	stateEmitterTime[3]				= 0.04;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.9;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";

};
$SRIFLE_FOR=5;
function SRifleImage::onFire(%this,%obj,%slot)
{
	if(!%obj.bulletloaded["rifle"]){%obj.bulletloaded["rifle"]=4;}
	if(%obj.Spistolreloading){
		if(1 > %obj.bulletloaded["rifle"]-1){
			return;
		}
		%obj.cancelSpistolreloading=1;
		%obj.Spistolreloading=0;
		cancel($Spistolreload[%obj]);
		$Spistolreload[%obj]=0;
	}
	if(1 > %obj.bulletloaded["rifle"]-1){
		%obj.playThread(2, shiftright);
		//centerprint(%obj.client,"Reloading...\c1" SPC %obj.bulletloaded["rifle"]-1 @ "\c0/\c1" @ 9 - %obj.bulletexpended["rifle"],200);
		%obj.Spistolreloading=1;
		$Spistolreload[%obj]=schedule(3600,0,"Spistolreload",%obj);
		return;
	}
	if(%obj.getDamagePercent() < 1.0)
		%obj.playThread(2, shiftright);

	%obj.bulletloaded["rifle"]--;
	centerprint(%obj.client,"Shots left:\c1" SPC %obj.bulletloaded["rifle"]-1 @ "\c0/\c1" @ 9 - %obj.bulletexpended["rifle"],400);
	%projectile = %this.projectile;
	%spread = 0.0003;
	%pvec = %obj.client.player.getvelocity();
	if(getword(%pvec,0) + getword(%pvec,1) + getword(%pvec,2) > 1 || getword(%pvec,0) + getword(%pvec,1) + getword(%pvec,2) < -1){
		%spread += 0.0014;
	}
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity+%astee);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);

	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = vectoradd(%obj.getMuzzlePoint(%slot),vectorscale(%vector,$SRIFLE_FOR));
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	MissionCleanup.add(%p);
	if(1 > %obj.bulletloaded["rifle"]-1){
		if(!%obj.Spistolreloading&&$Spistolreload[%obj]==0){
			%obj.playThread(2, shiftdown);
			centerprint(%obj.client,"Reloading...\c1" SPC %obj.bulletloaded["rifle"]-1 @ "\c0/\c1" @ 9 - %obj.bulletexpended["rifle"],200);
			%obj.pistolreloading=1;
			$pistolreload[%obj]=schedule(3600,0,"Spistolreload",%obj);
			return;
		}
	}
	return %p;
	

}

function SRifleProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{				
	if(!isobject(%col)){
		return;
	}
	if(%col.getclassname() $= "Player" || %col.getclassname() $= "AIPlayer"){
		%col.setvelocity(vectoradd(%col.getvelocity(),vectorscale(%col.getvelocity(),-0.5)));
	}
	
	Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
}

function Spistolreload(%obj){
	if(!isobject(%obj)||%obj.getdamagelevel() >= %obj.getdatablock().maxdamage){
		return;
	}
	if(%obj.cancelSpistolreloading){
		%obj.cancelSpistolreloading=0;
	}
	if(%obj.getmountedimage(0)!$=nametoid("SRifleimage")){
		%obj.cancelSpistolreloading=1;
		%obj.Spistolreloading=0;
		cancel($Spistolreload[%obj]);
		$Spistolreload[%obj]=0;
		return;
	}
	if(%obj.bulletexpended["rifle"] >= 9){
		%obj.cancelSpistolreloading=1;
		%obj.Spistolreloading=0;
		cancel($Spistolreload[%obj]);
		$Spistolreload[%obj]=0;
		return;
	}
	%obj.playThread(2, shiftdown);
	%obj.bulletloaded["rifle"]++;
	%obj.bulletexpended["rifle"]++;
	centerprint(%obj.client,"Reloading...\c1" SPC %obj.bulletloaded["rifle"]-1 @ "\c0/\c1" @ 9 - %obj.bulletexpended["rifle"],200);
	if(%obj.bulletloaded["rifle"] < 4){
		$pistolreload[%obj]=schedule(100,0,"Spistolreload",%obj);
	}else{
		%obj.Spistolreloading=0;
		$Spistolreload[%obj]=0;
	}
}

package Spistolmountreload
{
function SRifleImage::onMount(%this,%obj,%slot)
{
	if(!%obj.client.player.bulletloaded["rifle"]){%obj.client.player.bulletloaded["rifle"]=4;}
	centerprint(%obj.client,"Ammo...\c1" SPC %obj.client.player.bulletloaded["rifle"]-1 @ "\c0/\c1" @ 9 - %obj.client.player.bulletexpended["rifle"],200);
	if(1 > %obj.client.player.bulletloaded["rifle"]-1){
		if(!%obj.client.player.Spistolreloading&&$Spistolreload[%obj.client.player]==0){
			%obj.client.player.playThread(2, shiftright);
			centerprint(%obj.client,"Reloading...\c1" SPC %obj.client.player.bulletloaded["rifle"]-1 @ "\c0/\c1" @ 9 - %obj.client.player.bulletexpended["rifle"],200);
			%obj.client.player.Spistolreloading=1;
			$Spistolreload[%obj.client.player]=schedule(3600,0,"Spistolreload",%obj.client.player);
			//return;
		}
	}
	parent::onMount(%this,%obj,%slot);
}
};
activatepackage(Spistolmountreload);



//bulletloaded["rifle"]
$bulletloadedmax["rifle"]=9;



































