//SPlasma.cs


//shell

//muzzle flash effects
datablock ParticleData(SPlasmaFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 45;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.0 0.9 0.9 0.9";
	colors[1]     = "0.0 0.9 0.5 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 0.1;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SPlasmaFlashEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 5.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SPlasmaFlashParticle";
};

datablock ParticleData(SPlasmaSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 325;
	lifetimeVarianceMS   = 55;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.6 0.6 0.9";
	colors[1]     = "0.5 0.6 0.5 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 0.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SPlasmaSmokeEmitter)
{
   ejectionPeriodMS = 3;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SPlasmaSmokeParticle";
};


//bullet trail effects
//datablock ParticleData(RbulletTrailParticle)
//{
//	dragCoefficient      = 3;
//	gravityCoefficient   = -0.0;
//	inheritedVelFactor   = 1.0;
//	constantAcceleration = 0.0;
//	lifetimeMS           = 1025;
//	lifetimeVarianceMS   = 55;
//	textureName          = "base/data/particles/dot";
//	spinSpeed		= 10.0;
//	spinRandomMin		= -500.0;
//	spinRandomMax		= 500.0;
//	colors[0]     = "0.7 0.3 0.3 0.07";
//	colors[1]     = "0.7 0.3 0.3 0.07";
//	sizes[0]      = 0.07;
//	sizes[1]      = 0.07;
//
//	useInvAlpha = false;
//};
//datablock ParticleEmitterData(RbulletTrailEmitter)
//{
//   ejectionPeriodMS = 1;
//   periodVarianceMS = 0;
//   ejectionVelocity = 0.0;
//   velocityVariance = 0.0;
//   ejectionOffset   = 0.0;
//   thetaMin         = 0;
//   thetaMax         = 90;
//   phiReferenceVel  = 0;
//   phiVariance      = 360;
//   overrideAdvance = false;
//   particles = "RbulletTrailParticle";
//};
datablock ParticleData(SPlasmaTrailParticle)
{
	dragCoefficient      = 99;
	gravityCoefficient   = -0.0;
	inheritedVelFactor   = 0.0;
	constantAcceleration = 0.0;
	lifetimeMS           = 1525;
	lifetimeVarianceMS   = 1;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 0.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.5 0.7 0.4 0.3";
	colors[1]     = "0.1 0.7 0.1 0.0";
	sizes[0]      = 0.32;
	sizes[1]      = 0.28;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SPlasmaTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 0.0;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SPlasmaTrailParticle";
};

datablock ParticleData(SPlasmaExplosionParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 700;
	lifetimeVarianceMS   = 400;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 0.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.4 0.9 0.5 0.9";
	colors[1]     = "0.4 0.9 0.4 0.0";
	sizes[0]      = 0.95;
	sizes[1]      = 1.05;

	useInvAlpha = true;
};
datablock ParticleEmitterData(SPlasmaExplosionEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 1.0;
   ejectionOffset   = 0.8;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SPlasmaExplosionParticle";
};


datablock ParticleData(SPlasmaExplosionRingParticle)
{
	dragCoefficient      = 8;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 300;
	lifetimeVarianceMS   = 100;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 0.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.1 0.9 0.7 0.9";
	colors[1]     = "0.1 0.9 0.1 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 0.65;

	useInvAlpha = false;
};
datablock ParticleEmitterData(SPlasmaExplosionRingEmitter)
{
	lifeTimeMS = 100;

   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 5;
   velocityVariance = 0.0;
   ejectionOffset   = 0.8;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "SPlasmaExplosionRingParticle";
};

datablock ExplosionData(SPlasmaExplosion)
{
   //explosionShape = "";
	soundProfile = bulletHitSound;

   lifeTimeMS = 180;

   particleEmitter = SPlasmaExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   emitter[0] = SPlasmaExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 2;
   lightStartColor = "0.3 0.6 0.7";
   lightEndColor = "0 0 0";

   damageRadius = 6.0;
   radiusDamage = 15;

   impulseRadius = 4.0;
   impulseForce = 500;
};


AddDamageType("SPlasma",   '%1 \c1 took a plasma glob.',    '%2 \c1plasma-ed\c0 %1\c1.',0.5,1);
datablock ProjectileData(SPlasmaProjectile)
{
   //projectileShapeName = "Add-ons/Weapon_Gun/bullet.dts";
   directDamage        = 35;
   directDamageType    = $DamageType::SPlasma;
   radiusDamageType    = $DamageType::SPlasma;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 000;
   verticalImpulse	  = 000;
   explosion           = SPlasmaExplosion;
   particleEmitter     = SPlasmaTrailEmitter;

   muzzleVelocity      = 130;
   velInheritFactor    = 0.2;

   armingDelay         = 00;
   lifetime            = 2000;
   fadeDelay           = 1500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   bounceAngle         = 60; //stick almost all the time
  // minStickVelocity    = 10;
   isBallistic         = true;
   gravityMod = 0.8;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";
};


//////////
// item //
//////////
datablock ItemData(SPlasmaItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "base/data/shapes/empty.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "SPlasma";
	iconName = "add-ons/script_blockrace/pioneerhg";
	doColorShift = false;
	colorShiftColor = "0.45 0.45 0.45 1.000";

	 // Dynamic properties defined by the scripts
	image = SPlasmaImage;
	canDrop = true;
};


////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(SPlasmaImage)
{
   // Basic Item properties
   shapeFile = "base/data/shapes/empty.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = BowItem;
   ammo = " ";
   projectile = SPlasmaProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = false;
   colorShiftColor = SPlasmaItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.15;
	stateTransitionOnTimeout[0]       = "Ready";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "preFire";
	stateAllowImageChange[1]         = true;
	stateSequence[1]	= "Ready";

	stateName[5]                     = "preFire";
	stateTimeoutValue[5]            = 0.25;
	stateTransitionOnTimeout[5]     = "Fire";
	stateAllowImageChange[5]         = true;
	stateSequence[5]	= "preFire";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Smoke";
	stateTimeoutValue[2]            = 0.09;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateWaitForTimeout[2]			= true;
	stateEmitter[2]					= SPlasmaFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateSound[2]					= gunShot1Sound;

	stateName[3] = "Smoke";
	stateEmitter[3]					= SPlasmaSmokeEmitter;
	stateEmitterTime[3]				= 0.1;
	stateEmitterNode[3]				= "muzzleNode";
	stateTimeoutValue[3]            = 0.55;
	stateTransitionOnTimeout[3]     = "Reload";

	stateName[4]			= "Reload";
	stateSequence[4]                = "Reload";
	stateTransitionOnTriggerUp[4]     = "Ready";
	stateSequence[4]	= "Ready";

};
//$SPlasma_FOR=5;
$SPlasma_cost=20;
function SPlasmaImage::onFire(%this,%obj,%slot)
{
	if(%obj.getdatablock().maxdamage - %obj.getdamagelevel() < $SPlasma_cost && !%obj.isarchon){
		centerprint(%obj.client,"Not Enough Energy! (" @ %obj.getdatablock().maxdamage - %obj.getdamagelevel() @ ")",400);
		return;
	}
	%obj.client.player.damage(%obj,0,$SPlasma_cost,$DamageType::SPlasma);
	centerprint(%obj.client,"Energy Left:\c1" SPC %obj.getdatablock().maxdamage - %obj.getdamagelevel(),400);
	%projectile = %this.projectile;
	%spread = 0.0009;
	%pvec = %obj.client.player.getvelocity();
	if(getword(%pvec,0) + getword(%pvec,1) + getword(%pvec,2) > 1 || getword(%pvec,0) + getword(%pvec,1) + getword(%pvec,2) < -1){
		%spread += 0.0014;
	}
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity+%astee);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);
	%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
	%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
	%velocity = MatrixMulVector(%mat, %velocity);

	%p = new (%this.projectileType)()
	{
		dataBlock = %projectile;
		initialVelocity = %velocity;
		initialPosition = %obj.getMuzzlePoint(%slot);
		sourceObject = %obj;
		sourceSlot = %slot;
		client = %obj.client;
	};
	if(%obj.isarchon){
		%p.setscale("0.7 0.7 0.7");
	}
	MissionCleanup.add(%p);
	if(%obj.isarchon){
		%shellcount=5;
		for(%i=0;%i<%shellcount;%i++){
			%spread += 0.001;
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity+%astee);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
	
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		%p.setscale("0.3 0.3 0.3");
		MissionCleanup.add(%p);
		}
	}
	return %p;
	

}

function SPlasmaProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{				
	if(!isobject(%col)){
		return;
	}
	if(%col.getclassname() $= "Player" || %col.getclassname() $= "AIPlayer"){
		%col.setvelocity(vectoradd(%col.getvelocity(),vectorscale(%col.getvelocity(),0.5)));
	}
	
	Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal);
}


package Splasmamountreload
{
function SPlasmaImage::onMount(%this,%obj,%slot)
{
	centerprint(%obj.client,"Energy...\c1" SPC %obj.client.player.getdatablock().maxdamage - %obj.client.player.getdamagelevel(),200);
	parent::onMount(%this,%obj,%slot);
}
function Armor::damage(%this, %obj, %sourceObject, %position, %damage, %damageType)
{
	if(%obj.client.curclass $= "fallen"){
		//centerprint(%obj.client,"Energy lost!\c1" SPC %obj.client.player.getdatablock().maxdamage - %obj.client.player.getdamagelevel(),200);
		%damage -= 1;
		if(%sourceObject.client.curclass $= "scout"){
			%damage-=1;
		}
		if(%sourceObject.client.curclass $= "harvester"){
			%damage+=2;
		}		
		if(%sourceObject.client.curclass $= "fuser"){
			%damage+=2;
		}
		if(%sourceObject.client.curclass $= "sentinel"){
			%damage+=1;
		}
		if(%damage <= 0){
			%damage=0;
		}
	}
	if(%obj.client.curclass $= "sentinel"){
		%damage -= 1;
		if(%sourceObject.client.curclass $= "scout"){
			%damage-=1;
		}
		if(%sourceObject.client.curclass $= "harvester"){
			%damage+=1;
		}		
		if(%sourceObject.client.curclass $= "fuser"){
			%damage+=1;
		}
		if(%sourceObject.client.curclass $= "fallen"){
			%damage-=2;
		}
		if(%damage <= 0){
			%damage=0;
		}
	}
	parent::damage(%this,%obj,%sourceObject,%position,%damage,%damageType);
	if(%obj.client.curclass $= "fallen"){
		centerprint(%obj.client,"Energy lost!\c1" SPC %obj.client.player.getdatablock().maxdamage - %obj.client.player.getdamagelevel(),200);
		//%damage -= 1;
		//if(%damage <= 0){
		//	%damage=0;
		//}
	}
}
};
activatepackage(Splasmamountreload);








































