datablock PlayerData(PlayerScoutArmor : PlayerStandardArmor)
{
   runForce = 34 * 90;
   runEnergyDrain = 0;
   minRunEnergy = 0;
   maxForwardSpeed = 10;
   maxBackwardSpeed = 9;
   maxSideSpeed = 9;

   maxForwardCrouchSpeed = 8;
   maxBackwardCrouchSpeed = 7;
   maxSideCrouchSpeed = 7;

   jumpForce = 10 * 95; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;
   maxDamage = 75;

	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	uiName = "Scout Player";
	showEnergyBar = false;

   runSurfaceAngle  = 55;
   jumpSurfaceAngle = 55;
   //firstPersonOnly=1;
};


datablock PlayerData(PlayerHunterArmor : PlayerStandardArmor)
{
   runForce = 26	 * 90;//30*90

   maxForwardSpeed = 8.5;//9
   maxBackwardSpeed = 7.5;
   maxSideSpeed = 7.5;

   jumpForce = 10 * 93; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	maxDamage = 90;

	uiName = "Hunter Player";
	showEnergyBar = false;
	//firstPersonOnly=1;
};

datablock PlayerData(PlayerSentinelArmor : PlayerStandardArmor)
{
   runForce = 29	 * 90;//30*90

   maxForwardSpeed = 7;//9
   maxBackwardSpeed = 6.5;
   maxSideSpeed = 6.5;

   jumpForce = 10 * 93; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	maxDamage = 110;

	uiName = "Sentinel Player";
	showEnergyBar = false;
	//firstPersonOnly=1;
};

datablock PlayerData(PlayerFallenArmor : PlayerStandardArmor)
{
   runForce = 20	 * 90;//30*90

   maxForwardSpeed = 5.5;//9
   maxBackwardSpeed = 5.5;
   maxSideSpeed = 5.5;

   jumpForce = 10 * 94; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 1;
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	maxDamage = 220;

	uiName = "Fallen Player";
	showEnergyBar = false;
	//firstPersonOnly=1;
};

datablock PlayerData(PlayerFuserArmor : PlayerStandardArmor)
{
   runForce = 26	 * 90;//30*90

   maxForwardSpeed = 8;//9
   maxBackwardSpeed = 8;
   maxSideSpeed = 8;

	rechargeRate = 0;
maxEnergy =  1000;
   repairRate = 0;

   jumpForce = 10 * 93; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	maxDamage = 100;

	uiName = "Fuser Player";
	showEnergyBar = true;
	//firstPersonOnly=1;
};
function PlayerFuserArmor::onAdd(%this,%obj)
{
   %obj.setenergylevel(0);
	%obj.firstfuser=1;
}

datablock PlayerData(PlayerHarvesterArmor : PlayerStandardArmor)
{
   runForce = 28	 * 90;//30*90

   maxForwardSpeed = 8.3;//9
   maxBackwardSpeed = 7.7;
   maxSideSpeed = 8;

   jumpForce = 10 * 93; //8.3 * 90;
   jumpEnergyDrain = 0;
   minJumpEnergy = 0;
   jumpDelay = 0;
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;

	maxDamage = 100;

	uiName = "Harvester Player";
	showEnergyBar = false;
	//firstPersonOnly=1;
};